<template>
  <!-- <section class="section container"> -->
  <div class="card register-card">
    <header class="card-header">
      <p class="card-header-title is-primary">用語新規登録</p>
      <button class="card-header-icon" aria-label="more options">
        <span class="icon">
          <i class="fas fa-angle-down" aria-hidden="true"></i>
        </span>
      </button>
    </header>
    <div class="card-content p-5">
      <div class="content">
        <div class="field">
          <label class="label">用語（10文字まで）</label>
          <div class="control">
            <input class="input" v-model="word" placeholder="Input a Word" />
            <p class="help is-danger" v-if="errs.isWordEmpty">
              用語は空欄にできません
            </p>
            <p class="help is-danger" v-if="errs.isWordLong">
              用語は10文字以内で入力してください
            </p>
          </div>
        </div>

        <div class="field">
          <label class="label">原文（10文字まで）</label>
          <div class="control">
            <input
              class="input"
              v-model="ori"
              placeholder="Input the Original"
            />
            <p class="help is-danger" v-if="errs.isOriLong">
              原文は10文字以内で入力してください
            </p>
          </div>
        </div>

        <div class="control">
          <button
            class="button"
            :class="{ 'is-primary': lang === 'zh2ja' }"
            @click="setLang('zh2ja')"
          >
            中国語 → 日本語
          </button>
          <button
            class="button"
            :class="{ 'is-primary': lang === 'ja2zh' }"
            @click="setLang('ja2zh')"
          >
            日本語 → 中国語
          </button>
          <button
            class="button"
            :class="{ 'is-primary': lang === 'ja' }"
            @click="setLang('ja')"
          >
            日本語のみ
          </button>
          <button
            class="button"
            :class="{ 'is-primary': lang === 'zh' }"
            @click="setLang('zh')"
          >
            中国語のみ
          </button>
        </div>

        <div class="field">
          <label class="label">コメント</label>
          <div class="control">
            <textarea
              class="textarea"
              v-model="comment"
              placeholder="Input comments"
            />
          </div>
        </div>

        <div class="field">
          <label class="label">作成者</label>
          <div class="control">
            <input class="card-footer-item input" v-model="author" />
          </div>
        </div>
      </div>
      <div class="block">
        <button class="button is-primary is-fullwidth" @click="validate">
          REGISTER
        </button>
      </div>
    </div>
    <div class="content" v-if="!errs.isAllClear">
      <p class="help is-danger">不正な入力値があります</p>
    </div>
    <div class="content" v-if="hasRegistered">
      <p>用語が登録されました！</p>
    </div>
  </div>

  <!-- </section> -->
</template>

<script setup lang="ts">
interface Props {
  moveOnFinish: Boolean;
}
const props = defineProps<Props>();

type Langs = "ja2zh" | "zh2ja" | "ja" | "zh";
const word = ref("");
const ori = ref("");
const author = ref("me");
const comment = ref("");
const lang = ref<Langs>("ja2zh");
const hasRegistered = ref(false);

const errs = ref({
  isWordEmpty: false,
  isWordLong: false,
  isOriLong: false,
  isAllClear: true,
});

const setLang = (newlang: Langs) => {
  lang.value = newlang;
};
const validate = () => {
  errs.value.isWordEmpty = word.value === "";
  errs.value.isWordLong = word.value.length > 10;
  errs.value.isOriLong = ori.value.length > 10;

  errs.value.isAllClear =
    !errs.value.isWordEmpty && !errs.value.isWordLong && !errs.value.isOriLong;

  if (errs.value.isAllClear) {
    register();
  }
};
const register = () => {
  const fields: Omit<StormCard, "No"> = {
    word: word.value,
    ori: ori.value,
    src: lang.value.startsWith("zh") ? "zh" : "ja",
    tgt: lang.value.endsWith("ja") ? "ja" : "zh",
    comment: comment.value,
    author: author.value,
    randamize: Math.floor(Math.random() * 5) + 1,
  };
  fetch("/api/setCard", { method: "POST", body: JSON.stringify(fields) })
    .then((res) => {
      if (res.ok) {
        res.text().then((t) => {
          if (props.moveOnFinish) {
            const router = useRouter();
            const query = `word=${fields.word}&ori=${fields.ori}&src=${fields.src}&tgt=${fields.tgt}&comment=${fields.comment}&author=${fields.author}`;
            router.push(`/storm/card?${query}`);
          } else {
            hasRegistered.value = true;
          }
        });
      } else {
        console.log(res);
      }
    })
    .catch((err) => {
      console.log(err);
    });
};
</script>

<style scoped>
.register-card {
  max-width: 50rem;
  margin-left: auto;
  margin-right: auto;
}
</style>
